/**
 * Created by tonyjiang on 16/3/15.
 */
import env from 'chanjet-env-check';
import Mutants from './Mutants';
import MutantsForChanjet from './MutantsChanjetImpl';
import MutantsForWeiXin from './MutantsWeiXinImpl';
import MutantsForBrowser from './MutantsBrowserImpl';

const classMap = {
    [env.constant.platform.chanjet] : MutantsForChanjet,
    [env.constant.platform.weixin] : MutantsForWeiXin,
    [env.constant.platform.browser] : MutantsForBrowser
};


if(!window.mutants){//如果mutants不存在,则直接实例化

    const instance = new classMap[env.platform]();
    instance.init();
    window.mutants = instance;

}else if(!(window.mutants instanceof Mutants)){//如果mutants存在,但不是Mutants的实例 , 则实例化并mixin

    const instance = new classMap[env.platform]();
    instance.init();
    window.mutants = window.mutants = Object.assign(instance , window.mutants);
}

export default window.mutants;