/**
 * Created by luosong on 16/6/6.
 */

let instance = null;

class NativeConfig {
    _orgId;
    _orgAccount;
    _ext;
    _userId;
    _platformExtension;

    static get instance() {
        return instance;
    }

    static parseConfig(config) {
        instance = new NativeConfig(config);
    }

    constructor(config) {
        if (config && config.data) {
            this._orgId = config.data.entId;
            this._userId = config.data.userid;
            this._ext = config.data.ext;
        }

        if(config.data.platformExtension){
            this._platformExtension = JSON.parse(config.data.platformExtension);

            if (this._platformExtension) {
                this._orgAccount = this._platformExtension.orgAccount;
            }
        }
        
    }

    /**
     * 返回当前的企业 ID
     * @returns {string | number}
     */
    get orgId() {
        return this._orgId;
    }

    /**
     * 返回当前企业账号
     * @returns {string}
     */
    get orgAccount() {
        return this._orgAccount;
    }

    /**
     * 返回 config 中的 platformExtension
     * @returns {Object}
     */
    get platformExtension() {
        return this._platformExtension;
    }

    /**
     * 返回扩展信息
     * @returns {string}
     */
    get ext(){
        return this._ext;
    }

    /**
     * 返回当前用户ID
     * @returns {String | number}
     */
    get userId(){
        return this._userId;
    }
}

export default NativeConfig;
